# Changelog for cobot-io

## [Unreleased]

## [0.1.3.9] - 2020-10-27
### Fixed
- FASTA parser can now parse empty lines with spaces. 

## [0.1.3.8] - 2020-10-22
### Fixed
- A couple of issues, that caused parametrization failures, fixed in bond restoring for PDB format.

## [0.1.3.7] - 2020-10-14
### Added
- Generic fasta parser. 

## [0.1.3.6] - 2020-07-14
### Added
- Convertation from `Model`s to `PDB`.
- Writer for `PDB`.
- `renameChains` function that renames chains in a model.

## [0.1.3.5] - 2020-05-26
### Fixed
- Correctly clean `BasecalledSequenceWithRawData`, including inner quality.

## [0.1.3.4] - 2020-05-14
### Added
- `instance Cleanable BasecalledSequenceWithRawData`.

## [0.1.3.3] - 2020-05-07
### Added
- Type and decoder for `ab1` with raw channel data and peak locations.
### Fixed
- Use supplied thresholds instead of default ones in the implementation of `cleanWith`;
- Do not run `IO` in `hspec` `Spec` monad, use `beforeAll`.

## [0.1.3.2] - 2020-04-15
### Changed
- Resolver version up.
- Moving from `less-wrong` to `biocad`.

## [0.1.3.1] - 2020-04-02
### Fixed
- Reading of insertion code for residues in MAE.

## [0.1.3.0] - 2020-03-27
### Added
- Residue index in `Structure`.
- Atom input index in `Structure`.
- Bond restoring for PDB.
- Tests for PDB -> Model conversion.
### Changed
- GlobalID now 0-based in mae, PDB, and MMTF.
### Fixed
- A lot of things.

## [0.1.2.10] - 2020-03-27
### Added
- Lenses for `Structure`.

## [0.1.2.9] - 2020-03-12
### Added
- Function `filterAtomsOfModel` to filter atoms of model by the given predicate.
### Fixed
- Grouping by residues when converting `Mae` to `Model`.

## [0.1.2.8] - 2020-03-12
### Added
- `instance Traversable (Sequence mk w)`.

## [0.1.2.7] - 2020-02-11
### Changed
- Support GHC-8.8.

## [0.1.2.6] - 2019-12-12
### Fixed
- Fixes for instance of `StructureModels` for `Mae` when working with structures without explicit chain names.

## [0.1.2.5] - 2019-12-24
### Fixed
- Possibility to have spaces in Fasta sequences.

## [0.1.2.4] - 2019-12-23
### Added
- Preprocessing for pdb-files.
- Pdb parser.

## [0.1.2.3] - 2019-12-12
### Fixed
- Fixes for .mae pasrser.
- Fixes for instance of `StructureModels` for `Mae`.

## [0.1.2.2] - 2019-11-27
### Added
- Instance of `StructureModels` for `Mae`.
### Fixed
- Fix for .mae pasrser.

## [0.1.2.1] - 2019-11-25
### Added
- Parser for `MAE`.

## [0.1.2.0] - 2019-09-03
### Added
- Parser for `FASTA`.
- Writer for `FASTA`.

## [0.1.1.1] - 2019-06-05
### Changed
- `length` on `Sequence` now works in O(1).

## [0.1.1.0] - 2019-05-13
### Added
- New version of module Bio.Sequence hat introduces `IsSequence` type class and `Sequence` datatype.
- Type `GenBankSequence` describing structure of .gb file.
- Parser for `GenBankSequence`.
- Writer for `GenBankSequence`.
### Changed
- ABI cleaner and decoder now work with type `ABIRaw`.

## [0.1.0.1] - 2019-02-28
### Added
- Field `chemCompType` in `Residue`.
### Fixed
- `codec10`.
